
alias EventManager {
  window -Cdpk0 +lt @Event -1 -1 490 395
  titlebar @Event Manager - $1 events
  DrawBG @Event 500 500
  set %EventManager.month $2
  set %EventManager.day $3
  set %EventManager.year $4
  drawtext -nr @Event $rgb(255,255,255) "Times New Roman" 20 $int($calc(245 - ($width(Viewing Events for $2 $3 $4,Times New Roman,20,1,1) / 2))) 5 Viewing Events for $2 $3 $4
  drawtext -nr @Event $rgb(255,255,255) "Times New Roman" 18 $int($calc(175 - ($width(Event Name,Times New Roman,18,1,1) / 2))) 45 Event Name
  drawpic -ntc @Event $rgb(0,0,0) 27 70 %Calendar.directory $+ previous.bmp
  LimitedEditBox @Event 57 67 230 25
  drawpic -ntc @Event $rgb(0,0,0) 292 70 %Calendar.directory $+ next.bmp
  drawtext -nr @Event $rgb(255,255,255) "Times New Roman" 18 $int($calc(175 - ($width(Event Description,Times New Roman,18,1,1) / 2))) 110 Event Description
  LimitedEditBox @Event 57 132 230 170
  set %EventManager.action $1
  if ($1 == Delete) { DrawButton @Event 160 320 85 30 Delete }
  elseif ($1 == Edit) { DrawButton @Event 160 320 85 30 Edit Event }
  else { DrawButton @Event 160 320 85 30 OK }
  DrawButton @Event 260 320 85 30 Cancel

  clock @Event 330 100
  editbox @Event 345 240 30 17
  editbox @Event 375 240 30 17
  editbox @Event 405 240 30 17

  drawrect @Event
  FirstEvent $2 $+ $3 $+ $4
}

; -----------------------------------------------------
; Find the 1st event for a given day, and
; write the information to the screen. Save
; the line number to the variable %c.eventline
; so it can be referenced for the Next and Previous
; buttons.
; FirstEvent MonthDayYear
; -----------------------------------------------------
alias -l FirstEvent {
  var %c.file = %Calendar.directory $+ busydays.dat
  var %c.counter = 1
  while (%c.counter <= $lines(%c.file)) {
    var %c.currentlineinfile = $read( [ %c.file ] ,l, [ %c.counter ] )
    if (%c.currentlineinfile == $1-) { 
      var %c.maketimer = $true
      break
    }
    inc %c.counter
  }

  if (%c.maketimer == $true) {
    ; Add the 1st event to the editbox and save the line # for future reference.
    set %c.linetosearch $chr(171) $+ $1-
    var %c.file %Calendar.directory $+ events.dat
    var %c.counter 1
    while (%c.counter <= $lines(%c.file)) {
      if ($read( [ %c.file ] ,l, [ %c.counter ] ) == %c.linetosearch) {
        var %c.currentlineinfile $read( [ %c.file ] ,l,$calc(%c.counter + 1))
        if (($chr(171) isin $read( [ %c.file ] ,l,$calc(%c.counter + 1))) || ($read( [ %c.file ] ,l,$calc(%c.counter + 1)) %c.file == $null)) {
          LimitedEditBox @Event 57 67 230 25 No Events for %EventManager.month %EventManager.day %EventManager.year
          write -dl $+ %c.counter %Calendar.directory $+ events.dat
          write -ds $+ [ [ %EventManager.month ] $+ [ %EventManager.day ] $+ [ %EventManager.year ] ] %Calendar.directory $+ busydays.dat
          set %EventManager.eventexists $false
          break
        }
        else {
          LimitedEditBox @Event 57 67 230 25 $gettok(%c.currentlineinfile,1,166)
          if ($numtok(%c.currentlineinfile,166) == 2) { 
            var %EventManager.hrs $gettok($gettok(%c.currentlineinfile,2,166),1,58)
            var %EventManager.mins $gettok($gettok(%c.currentlineinfile,2,166),2,58)
            var %EventManager.tod $gettok($gettok(%c.currentlineinfile,2,166),3,58)
            AddHands %EventManager.hrs %EventManager.mins @Event 330 100
            if (%EventManager.hrs == 00) { EditBox @Event 345 240 30 17 12 }
            else { editbox @Event 345 240 30 17 %EventManager.hrs }
            editbox @Event 375 240 30 17 %EventManager.mins
            editbox @Event 405 240 30 17 %EventManager.tod
          }
          if ($numtok(%c.currentlineinfile,166) == 3) { 
            WriteInDescription $gettok(%c.currentlineinfile,2,166) 
            var %EventManager.hrs $gettok($gettok(%c.currentlineinfile,3,166),1,58)
            var %EventManager.mins $gettok($gettok(%c.currentlineinfile,3,166),2,58)
            var %EventManager.tod $gettok($gettok(%c.currentlineinfile,3,166),3,58)
            AddHands %EventManager.hrs %EventManager.mins @Event 330 100
            if (%EventManager.hrs == 00) { EditBox @Event 345 240 30 17 12 }
            else { editbox @Event 345 240 30 17 %EventManager.hrs }
            editbox @Event 375 240 30 17 %EventManager.mins
            editbox @Event 405 240 30 17 %EventManager.tod
          }
          set %c.eventline $calc(%c.counter + 1)
          break
        }
      }
      inc %c.counter  
    }
  }
  else { 
    LimitedEditBox @Event 57 67 230 25 No Events for %EventManager.month %EventManager.day %EventManager.year
    set %EventManager.eventexists $false
  }
  unset %c.linetosearch     
}

; -----------------------------
; Alias to find the previous
; event for a day.
; -----------------------------
alias -l PreviousEvent {
  var %EventManager.prevline = $calc(%c.eventline - 1)
  if (($chr(171) !isin $read( [ %Calendar.directory ] $+ events.dat,l, [ %EventManager.prevline ] )) && ($read( [ %Calendar.directory ] $+ events.dat,l, [ %EventManager.prevline ] ) != $null)) {
    set %c.eventline %EventManager.prevline
    var %c.currentlineinfile = $read( [ %Calendar.directory ] $+ events.dat,l, [ %c.eventline ] )
    LimitedEditBox @Event 57 67 230 25 $gettok(%c.currentlineinfile,1,166)
    if ($numtok(%c.currentlineinfile,166) == 2) { 
      var %EventManager.hrs $gettok($gettok(%c.currentlineinfile,2,166),1,58)
      var %EventManager.mins $gettok($gettok(%c.currentlineinfile,2,166),2,58)
      var %EventManager.tod $gettok($gettok(%c.currentlineinfile,2,166),3,58)
      AddHands %EventManager.hrs %EventManager.mins @Event 330 100
      if (%EventManager.hrs == 00) { EditBox @Event 345 240 30 17 12 }
      else { editbox @Event 345 240 30 17 %EventManager.hrs }
      editbox @Event 375 240 30 17 %EventManager.mins
      editbox @Event 405 240 30 17 %EventManager.tod
    }
    if ($numtok(%c.currentlineinfile,166) == 3) { 
      WriteInDescription $gettok(%c.currentlineinfile,2,166) 
      var %EventManager.hrs $gettok($gettok(%c.currentlineinfile,3,166),1,58)
      var %EventManager.mins $gettok($gettok(%c.currentlineinfile,3,166),2,58)
      var %EventManager.tod $gettok($gettok(%c.currentlineinfile,3,166),3,58)
      AddHands %EventManager.hrs %EventManager.mins @Event 330 100
      if (%EventManager.hrs == 00) { EditBox @Event 345 240 30 17 12 }
      else { editbox @Event 345 240 30 17 %EventManager.hrs }
      editbox @Event 375 240 30 17 %EventManager.mins
      editbox @Event 405 240 30 17 %EventManager.tod
    }
  }
}

; -----------------------------
; Alias to find the next event
; for a day.
; -----------------------------
alias -l NextEvent {
  var %EventManager.nextline = $calc(%c.eventline + 1)
  if (($chr(171) !isin $read( [ %Calendar.directory ] $+ events.dat,l, [ %EventManager.nextline ] )) && ($read( [ %Calendar.directory ] $+ events.dat,l, [ %EventManager.nextline ] ) != $null)) {
    set %c.eventline %EventManager.nextline
    var %c.currentlineinfile = $read( [ %Calendar.directory ] $+ events.dat,l, [ %c.eventline ] )
    LimitedEditBox @Event 57 67 230 25 $gettok(%c.currentlineinfile,1,166)
    if ($numtok(%c.currentlineinfile,166) == 2) { 
      var %EventManager.hrs $gettok($gettok(%c.currentlineinfile,2,166),1,58)
      var %EventManager.mins $gettok($gettok(%c.currentlineinfile,2,166),2,58)
      var %EventManager.tod $gettok($gettok(%c.currentlineinfile,2,166),3,58)
      AddHands %EventManager.hrs %EventManager.mins @Event 330 100
      if (%EventManager.hrs == 00) { EditBox @Event 345 240 30 17 12 }
      else { editbox @Event 345 240 30 17 %EventManager.hrs }
      editbox @Event 375 240 30 17 %EventManager.mins
      editbox @Event 405 240 30 17 %EventManager.tod
    }
    if ($numtok(%c.currentlineinfile,166) == 3) { 
      WriteInDescription $gettok(%c.currentlineinfile,2,166) 
      var %EventManager.hrs $gettok($gettok(%c.currentlineinfile,3,166),1,58)
      var %EventManager.mins $gettok($gettok(%c.currentlineinfile,3,166),2,58)
      var %EventManager.tod $gettok($gettok(%c.currentlineinfile,3,166),3,58)
      AddHands %EventManager.hrs %EventManager.mins @Event 330 100
      if (%EventManager.hrs == 00) { EditBox @Event 345 240 30 17 12 }
      else { editbox @Event 345 240 30 17 %EventManager.hrs }
      editbox @Event 375 240 30 17 %EventManager.mins
      editbox @Event 405 240 30 17 %EventManager.tod   
    }
  }
}

; ----------------------------------------
; Write the event description into the
; large edit box.
; WriteInDescription Description
; ----------------------------------------
alias -l WriteInDescription {
  LimitedEditBox @Event 57 132 230 170
  if ($width($1-,Times New Roman,14,1,1) > 228) {
    set %CAdd.descriptiontoks $numtok($1-,32)
    set %CAdd.counter 1
    set %CAdd.ypos 134
    set %CAdd.lengthcounter 1
    while (%CAdd.counter <= %CAdd.descriptiontoks) {
      set %CAdd.currentword $gettok($1-,%CAdd.counter,32)
      set %CAdd.lengthcounter $calc(%CAdd.lengthcounter + $width(%CAdd.currentword,Times New Roman,14,1,1) + 4)
      if (%CAdd.lengthcounter > 228) {
        drawtext -r @Event $rgb(0,0,0) "Times New Roman" 14 58 %CAdd.ypos %CAdd.limiteddesc
        set %CAdd.lengthcounter $calc(1 + $width(%CAdd.currentword,Times New Roman,14,1,1))
        set %CAdd.limiteddesc %CAdd.currentword
        set %CAdd.ypos $calc(%CAdd.ypos + 14)
      }
      else {
        set %CAdd.limiteddesc [ [ %CAdd.limiteddesc ] %CAdd.currentword ]
      }
      inc %CAdd.counter
      if (%CAdd.ypos > 294) { return }
    }
    drawtext -r @Event $rgb(0,0,0) "Times New Roman" 14 58 %CAdd.ypos %CAdd.limiteddesc
  }
  else {
    drawtext -r @Event $rgb(0,0,0) "Times New Roman" 14 58 134 $1-
  }
  unset %CAdd.*
}

menu @Event {
  sclick: {    
    if ($inrect($mouse.x,$mouse.y,27,70,24,18)) { set %EventManager.clicked PreviousEvent }
    if ($inrect($mouse.x,$mouse.y,292,70,24,18)) { set %EventManager.clicked NextEvent }
    if ($inrect($mouse.x,$mouse.y,160,320,85,30)) { 
      set %EventManager.clicked OkButton
      if (%EventManager.action == Delete) { DrawButtonDown @Event 160 320 85 30 Delete }
      elseif (%EventManager.action == Edit) { DrawButtonDown @Event 160 320 85 30 Edit Event }
      else { DrawButtonDown @Event 160 320 85 30 OK }
    }
    if ($inrect($mouse.x,$mouse.y,260,320,85,30)) { 
      set %EventManager.clicked Cancel
      DrawButtonDown @Event 260 320 85 30 Cancel
    }
  }
  uclick: {
    if (($inrect($mouse.x,$mouse.y,27,70,24,18)) && (%EventManager.clicked == PreviousEvent)) { PreviousEvent }
    if (($inrect($mouse.x,$mouse.y,292,70,24,18)) && (%EventManager.clicked == NextEvent)) { NextEvent }
    if (($inrect($mouse.x,$mouse.y,160,320,85,30)) && (%EventManager.clicked == OkButton)) {
      unset %CalMenu.menuopen 
      if ((%EventManager.action == Delete) && (%EventManager.eventexists != $false)) { 
        DrawButton @Event 160 320 85 30 Delete
        write -dl $+ %c.eventline %Calendar.directory $+ events.dat
        FirstEvent %EventManager.month $+ %EventManager.day $+ %EventManager.year
        .timerClose -m 1 10 window -c @Event
        .timerUpdate -m 1 50 ReDrawWindow
        .timerUpdate1 -m 1 12 UpdateEventTimers
      }
      elseif ((%EventManager.action == Edit) && (%EventManager.eventexists != $false)) { 
        DrawButton @Event 160 320 85 30 Edit Event
        AddEvent %EventManager.month %EventManager.day %EventManager.year Edit %c.eventline
        .timerClose -m 1 10 window -c @Event
      }
      else { 
        DrawButton @Event 160 320 85 30 OK
        unset %EventManager.*
        .timerClose -m 1 10 window -c @Event
        .timerUpdate -m 1 50 ReDrawWindow
      }
    }
    if (($inrect($mouse.x,$mouse.y,260,320,85,30)) && (%EventManager.clicked == Cancel)) { 
      DrawButton @Event 260 320 85 30 Cancel
      unset %EventManager.* %CalMenu.*
      .timerUpdate -m 1 50 ReDrawWindow
      window -c @Event
    }
    else {
      if (%EventManager.action == Delete) { DrawButton @Event 160 320 85 30 Delete }
      elseif (%EventManager.action == Edit) { DrawButton @Event 160 320 85 30 Edit Event }
      else { DrawButton @Event 160 320 85 30 OK }
      DrawButton @Event 260 320 85 30 Cancel
      unset %EventManager.clicked
    }
  }
}

; ---------------------------------
; Draw an edit box. Unfortunately,
; This one can't be edited :\
; Accepts paramaters as follows:
; EditBox window x y w h text
; ---------------------------------

alias -l LimitedEditBox {
  drawrect -nrf $1 $rgb(255,255,255) 1 $2 $3 $4 $5
  drawline -nr $1 $rgb(223,223,223) 2 $2 $calc($3 + $5 - 1) $calc($2 + $4 - 1) $calc($3 + $5 - 1) $calc($2 + $4 - 1) $3
  drawline -nr $1 $rgb(shadow) 2 $2 $calc($3 + $5 - 1) $2 $3 $calc($2 + $4) $3
  if ($6 != $null) { 
    if ($width($6-,Times New Roman,14,1,1) > $4) { drawtext -ncr $1 $rgb(0,0,0) "Times New Roman" 14 $2 $int($calc(($5 / 2) - ($height($6-,Times New Roman,14) / 2) + $3 )) $4 $5 $6- }
    else { drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 14 $int($calc(($4 / 2) - ($width($6-,Times New Roman,14,1,1) / 2) + $2 )) $int($calc(($5 / 2) - ($height($6-,Times New Roman,14) / 2) + $3 )) $6- }
  }
  drawrect $1
}
