; +------------------------------------------------+
; | Calendar v1.01 - By Smay                       |
; |                                                |
; |      ---------- Install.mrc -----------        |
; | This is the installation file for the calendar |
; | And must be run in order for the calendar to   |
; | Work.                                          |
; | It sets 3 variables: %Calendar.directory       |
; | %Calendar.bgpicture, and %Calendar.background. |
; | It also copies all needed files to a directory |
; | And loads the .mrc files.                      |
; | Install will not continue until a background   |
; | is chosen, and the required files are all      |
; | located (Must be in the install directory)     |
; |                                                |
; | /load -rs install.mrc                          |
; +------------------------------------------------+

on 1:load: {
  if ($version < 5.9) {
    echo 4 -a *** You must be running mIRC v. 5.9 or greater to use this script. You can download the latest version at www.mirc.com
    .timerUnload 1 1 unload -rs $script
    halt
  }
  
  set %Calendar.directory $scriptdir
  
  if ($exists($scriptdirCalendar.mrc) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ Calendar.mrc. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirDates.mrc) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ Dates.mrc. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirAddevent.mrc) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ Addevent.mrc. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirEventManager.mrc) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ EventManager.mrc. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirmenus.mrc) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ menus.mrc. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirnext.bmp) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ next.bmp. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirprevious.bmp) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ previous.bmp. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirbg1.bmp) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ bg1.bmp. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirbg1_sml.bmp) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ bg1_sml.bmp. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirbg2.bmp) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ bg2.bmp. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirbg2_sml.bmp) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ bg2_sml.bmp. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirbg3.bmp) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ bg3.bmp. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirbg3_sml.bmp) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ bg3_sml.bmp. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }
  elseif ($exists($scriptdirreadme.txt) != $true) {
    echo 4 -a *** Error. Could not find %Calendar.directory $+ readme.txt. Please ensure that this file exists and is in the correct directory.
    echo 4 -a *** Installation Aborted
    unset %Calendar.directory
    halt
  }

  InstallGUI
}

; ---------------------------------------
; The Install Screen for Calendar.
; Lets the user set the directory and
; choose background colors. Foreground
; Is automatically set.
; ---------------------------------------

alias -l InstallGUI {
  window -Cdopk0 +lt @Install -1 -1 300 142
  titlebar @Install Calendar v1.01
  drawrect -rf @Install $rgb(0,0,0) 1 0 0 300 142
  drawtext -ohr @Install $rgb(255,255,255) "Times New Roman" 18 $int($calc(150 - ($width(Select background,Times New Roman,18,1,1) / 2))) 10 Select Background
  DrawRadio @Install 25 47 10 10
  drawpic @Install 40 30 $scriptdirbg1_sml.bmp
  DrawRadio @Install 115 47 10 10
  drawpic @Install 130 30 $scriptdirbg2_sml.bmp
  drawrect -r @Install $rgb(255,255,255) 1 130 30 48 48
  DrawRadio @Install 205 47 10 10
  drawpic -s @Install 220 30 48 48 $scriptdirbg3_sml.bmp
  DrawButton @Install 57 82 85 30 Next >>
  DrawButton @Install 152 82 85 30 Cancel
  set %CInstall.doinstall yes
  set %CInstall.stepNum 1
}

alias -l InstallGUI2 {
  clear @Install
  set %CInstall.stepNum 2
  drawrect -rf @Install $rgb(0,0,0) 1 0 0 300 142
  drawtext -ohr @Install $rgb(255,255,255) "Times New Roman" 18 $int($calc(150 - ($width(Select Install Directory,Times New Roman,18,1,1) / 2))) 10 Select Install Directory
  editbox @Install 10 43 200 20 $scriptdir
  DrawButton @Install 215 43 65 20 Change
  set %CInstall.currentdir $true
  set %CInstall.doinstall yes
  DrawButton @Install 57 82 85 30 Install
  DrawButton @Install 152 82 85 30 Cancel
}
 
; ------------------------------------
; Install the script already!!!
; ------------------------------------

alias -l InstallIt {
  if (%CInstall.currentdir == $true) { 
    CInstall.FakeInstall 1
    halt 
  }
  else { 
    .mkdir %Calendar.directory
    CInstall.CountUp 1
  }
  CInstall.DrawText Copying Program Files..
  CInstall.CountUp 3
  
  CInstall.CopyScriptFiles 1 6
}

alias -l CInstall.CopyScriptFiles {
  var %CInstall.filenames Dates.mrc Calendar.mrc Addevent.mrc menus.mrc EventManager.mrc Install.mrc
  .copy -o $scriptdir $+ $gettok(%CInstall.filenames,$1,32) [ %Calendar.directory $+ [ $gettok(%CInstall.filenames,$1,32) ] ]
  CInstall.CountUp $2
  if ($1 < 6) { .timerCopyNextFile -m 1 150 CInstall.CopyScriptFiles $calc($1 + 1) $calc($2 + $rand(3,4)) }
  else { 
    CInstall.DrawText Copying Program Files..Done
    CInstall.DrawText Copying Image Files..
    CInstall.CountUp $calc($2 + 2)
    .timerCopyImages -m 1 100 CInstall.CopyImageFiles 1 $calc($2 + 4) 
  }
}

alias -l CInstall.CopyImageFiles {
  var %CInstall.filenames next.bmp previous.bmp bg1.bmp bg1_sml.bmp bg2.bmp bg2_sml.bmp bg3.bmp bg3_sml.bmp CalendarLogo.jpg arrows.bmp readme.txt numbers.bmp letters2.bmp
  .copy -o $scriptdir $+ $gettok(%CInstall.filenames,$1,32) [ %Calendar.directory $+ [ $gettok(%CInstall.filenames,$1,32) ] ]
  CInstall.CountUp $2
  if ($1 < 13) { .timerCopyNextFile -m 1 150 CInstall.CopyImageFiles $calc($1 + 1) $calc($2 + 3) }
  else { 
    CInstall.DrawText Copying Image Files..Done
    CInstall.DrawText Loading program files ...
    CInstall.CountUp $2
    .timerLoadScripts -m 1 100 CInstall.LoadScripts 1 $calc($2 + 2)
  }
}

alias -l CInstall.LoadScripts {
  var %CInstall.filenames Dates.mrc Calendar.mrc Addevent.mrc menus.mrc EventManager.mrc
  .load -rs [ %Calendar.directory $+ [ $gettok(%CInstall.filenames,$1,32) ] ]
  CInstall.CountUp $2
  if ($1 < 5) { .timerLoadNextScript -m 1 150 CInstall.LoadScripts $calc($1 + 1) $calc($2 + $rand(3,4)) }
  else { .timerFinishLoading -m 1 100 CInstall.FinishLoading $calc($2 + 1) }
}

alias -l CInstall.FinishLoading {
  write -c %Calendar.directory $+ events.dat
  CInstall.CountUp 96
  write -c %Calendar.directory $+ busydays.dat
  CInstall.CountUp 98
  CInstall.DrawText Loading program files ... Done
  CInstall.CountUp 99
  set %Calendar.bgpicture [ %Calendar.directory $+ [ %Calendar.bgpicture ] ]
  CInstall.CountUp 100
  SuccessfulInstall
}

alias -l CInstall.FakeInstall {
  CInstall.CountUp $1
  if ($1 < 72) { .timerFakeInstall -m 1 50 CInstall.FakeInstall $calc($1 + $rand(1,4)) }
  else { CInstall.LoadScripts 1 72 }
}
; ---------------------------------
; Successful Installation
; ---------------------------------

alias -l SuccessfulInstall {
  .timerClose 1 3 window -c @Install
  .timerUnload 1 4 .unload -rs $script
  unset %CInstall.*
  .timerOpen 1 4 Calendar
  .timerReadme 1 5 run notepad %Calendar.directory $+ readme.txt
}

; -----------------------------------
; Change Installation Directory
; -----------------------------------

alias -l ChangeInstallDir {
  set %CInstall.validdir yes
  set %CInstall.directory $input(Select the new Install Directory: $crlf $+ ex. C:\Calendar,1,Select Install Directory,%Calendar.directory)
  if (%CInstall.directory != $null) {
    if (($left(%CInstall.directory ,1) isletter) && ($right($left(%CInstall.directory ,2),1) == $chr(58))) { }
    else { set %CInstall.validdir no }
    if ($right(%CInstall.directory ,1) != \) { set %CInstall.directory [ %CInstall.directory ] $+ \ }
    if ($isdir(%CInstall.directory)) { 
      if ((%CInstall.directory == %Calendar.directory) || (%CInstall.directory == $scriptdir) || ($isdir( %CInstall.directory ) == $false)) { }
      else {
        if ($input(Directory Already exists! Files may be overwritten! Continue?,296,WARNING) != $yes) { set %CInstall.validdir no }
      }
    }
    if (%CInstall.directory == $scriptdir) { set %CInstall.currentdir $true }
    else { set %CInstall.currentdir $false }
  }
  else { 
    set %CInstall.directory $scriptdir 
    set %CInstall.validdir yes
  }
  if (%CInstall.validdir != no) { 
    set %Calendar.directory [ %CInstall.directory ]
    editbox @Install 10 43 200 20 %Calendar.directory
    set %CInstall.doinstall yes  
  }
  else { set %CInstall.doinstall no }
}

; -------------------------------------
; Draw a clickable button.
; Alias for both unclicked and clicked
; Accepts paramaters as follows:
; DrawButton window x y w h text
; -------------------------------------

alias -l DrawButton {
  drawrect -nrf $1 $rgb(face) 1 $2 $3 $4 $5
  drawrect -nr $1 $rgb(shadow) 1 $2 $3 $4 $5
  drawline -nr $1 $rgb(hilight) 1 $2 $calc($3 + $5 - 1) $2 $calc($3 + 1) $calc($2 + $4) $calc($3 + 1)
  if ($6 != $null) { drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 14 $int($calc(($4 / 2) - ($width($6-,Times New Roman,14,1,1) / 2) + $2 )) $int($calc(($5 / 2) - ($height($6-,Times New Roman,14) / 2) + $3 )) $6- }
  drawrect $1
}

alias -l DrawButtonDown {
  drawrect -nrf $1 $rgb(face) 1 $2 $3 $4 $5
  drawrect -nr $1 $rgb(frame) 1 $2 $3 $4 $5
  if ($6 != $null) { drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 14 $int($calc(($4 / 2) - ($width($6-,Times New Roman,14,1,1) / 2) + $2 )) $int($calc(($5 / 2) - ($height($6-,Times New Roman,14) / 2) + $3 )) $6- }
  drawrect $1
}

; ---------------------------------------------
; Draw a RadioButton. 
; Alias for all 3 phases - UnClicked, Clicked,
; and clicking.
; Accepts paramaters as follows:
; DrawRadio window x y w h
; ---------------------------------------------

alias -l DrawRadio {
  drawrect -nrfe $1 $rgb(255,255,255) 1 $2 $3 $4 $5
  drawrect -nre $1 $rgb(shadow) 1 $2 $3 $4 $5
  drawrect $1
}

alias -l DrawRadioClicking {
  drawrect -nrfe $1 $rgb(255,255,255) 1 $2 $3 $4 $5
  drawrect -nre $1 $rgb(shadow) 1 $2 $3 $4 $5
  drawrect -nrfe $1 $rgb(face) 1 $calc($2 + 1) $calc($3 + 1) $calc($4 - 1) $calc($5 - 1)
  drawrect -nrfe $1 $rgb(0,0,0) 1 $calc($2 + 3) $calc($3 + 3) $calc($4 - 6) $calc($5 - 6)
  drawrect $1
}

alias -l DrawRadioClicked {
  drawrect -nrfe $1 $rgb(255,255,255) 1 $2 $3 $4 $5
  drawrect -nre $1 $rgb(shadow) 1 $2 $3 $4 $5
  drawrect -nrfe $1 $rgb(0,0,0) 1 $calc($2 + 3) $calc($3 + 3) $calc($4 - 6) $calc($5 - 6)
  drawrect $1
}
  
; ---------------------------------
; Draw an edit box. Unfortunately,
; This one can't be edited :\
; Accepts paramaters as follows:
; EditBox window x y w h text
; ---------------------------------

alias -l EditBox {
  drawrect -nrf $1 $rgb(255,255,255) 1 $2 $3 $4 $5
  drawline -nr $1 $rgb(223,223,223) 2 $2 $calc($3 + $5 - 1) $calc($2 + $4 - 1) $calc($3 + $5 - 1) $calc($2 + $4 - 1) $3
  drawline -nr $1 $rgb(shadow) 2 $2 $calc($3 + $5 - 1) $2 $3 $calc($2 + $4) $3
  if ($6 != $null) { drawtext -nr $1 $rgb(0,0,0) "Times New Roman" 14 $int($calc(($4 / 2) - ($width($6-,Times New Roman,14,1,1) / 2) + $2 )) $int($calc(($5 / 2) - ($height($6-,Times New Roman,14) / 2) + $3 )) $6- }
  drawrect $1
}

alias InstallGUI3 {
  window -Cdop +l @Install -1 -1 300 142
  drawrect -rf @Install $rgb(0,0,0) 1 0 0 300 142
  .timerDrawInstall -m 1 50 CInstall.DropDownLines 0
}

alias -l CInstall.DropDownLines {
  drawline -nr @Install $rgb(0,255,0) 1 10 0 10 $1
  drawline -nr @Install $rgb(0,255,0) 1 280 0 280 $1
  drawdot @Install
  if ($1 < 70) { .timerCInstall.DropDownLines -m 1 10 CInstall.DropDownLines $calc($1 + 2) }
  else { .timerCInstall.AcrossLines -m 1 10 CInstall.AcrossLines 10 280 }  
}

alias -l CInstall.AcrossLines {
  drawline -nr @Install $rgb(0,255,0) 1 280 70 $2 70
  drawline -nr @Install $rgb(0,255,0) 1 10 70 $1 70
  drawdot @Install
  if ($1 < 30) { .timerCInstall.AcrossLines -m 1 10 CInstall.AcrossLines $calc($1 + 2) $calc($2 - 2) }
  else { .timerDrawProgBox -m 1 10 CInstall.DrawProgBox.1 70 70 } 
}

alias -l CInstall.DrawProgBox.1 {
  drawline -nr @Install $rgb(0,255,0) 1 30 70 30 $1
  drawline -nr @Install $rgb(0,255,0) 1 30 70 30 $2
  drawline -nr @Install $rgb(0,255,0) 1 260 70 260 $1
  drawline -nr @Install $rgb(0,255,0) 1 260 70 260 $2
  drawdot @Install
  if ($1 > 60) { .timerDrawProgBox -m 1 10 CInstall.DrawProgBox.1 $calc($1 - 2) $calc($2 + 2) }
  else { .timerDrawProgBox -m 1 10 CInstall.DrawProgBox.2 30 260 | .timerDrawProgBoxLines 1 2 CInstall.DrawProgBox.3 33 }
}

alias -l CInstall.DrawProgBox.2 {
  drawline -nr @Install $rgb(0,255,0) 1 30 60 $1 60
  drawline -nr @Install $rgb(0,255,0) 1 30 80 $1 80
  drawline -nr @Install $rgb(0,255,0) 1 260 60 $2 60
  drawline -nr @Install $rgb(0,255,0) 1 260 80 $2 80
  drawdot @Install
  if ($1 < 145) { .timerDrawProgBox -m 1 10 CInstall.DrawProgBox.2 $calc($1 + 2) $calc($2 - 2) }
  else { .timerDrawPctBox -m 1 10 CInstall.DrawPctBox.1 60 }
}

alias -l CInstall.DrawProgBox.3 {
  drawline -r @Install $rgb(0,60,0) 1 $1 62 $1 79
  if ($1 < 258) { .timerDrawProgBoxLines -m 1 10 CInstall.DrawProgBox.3 $calc($1 + 3) }
}

alias -l CInstall.DrawPctBox.1 {
  drawline -nr @Install $rgb(0,255,0) 1 145 60 145 $1
  drawdot @Install
  if ($1 > 40) { .timerDrawPctBox -m 1 10 CInstall.DrawPctBox.1 $calc($1 - 2) }
  else { .timerDrawPctBox -m 1 10 CInstall.DrawPctBox.2 145 145 Bottom }
}

alias -l CInstall.DrawPctBox.2 {
  if ($3 == Bottom) {
    drawline -nr @Install $rgb(0,255,0) 1 145 40 $1 40
    drawline -nr @Install $rgb(0,255,0) 1 145 40 $2 40
    drawdot @Install
    if ($1 > 123) { .timerDrawPctBox -m 1 10 CInstall.DrawPctBox.2 $calc($1 - 2) $calc($2 + 2) Bottom }
    else { .timerDrawPctBox -m 1 10 CInstall.DrawPctBox.2 40 40 Sides }
  }
  elseif ($3 == Sides) {
    drawline -nr @Install $rgb(0,255,0) 1 123 40 123 $1
    drawline -nr @Install $rgb(0,255,0) 1 167 40 167 $2
    drawdot @Install
    if ($1 > 20) { .timerDrawPctBox -m 1 10 CInstall.DrawPctBox.2 $calc($1 - 2) $calc($2 - 2) Sides }
    else { .timerDrawPctBox -m 1 10 CInstall.DrawPctBox.2 123 167 Top }
  }
  elseif ($3 == Top) {
    drawline -nr @Install $rgb(0,255,0) 1 123 20 $1 20
    drawline -nr @Install $rgb(0,255,0) 1 167 20 $2 20
    drawdot @Install
    if ($1 <= 145) { .timerDrawPctBox -m 1 10 CInstall.DrawPctBox.2 $calc($1 + 2) $calc($2 - 2) Top }
    else { 
      drawpic -n @Install 132 24 90 0 8 13 $scriptdirnumbers.bmp
      drawpic -n @Install 142 24 90 0 8 13 $scriptdirnumbers.bmp
      drawpic -n @Install 152 24 90 0 8 13 $scriptdirnumbers.bmp
      drawdot @Install
      CInstall.DrawText Preparing for Installation
      .timerPrepWait1 -m 1 500 CInstall.DrawText Preparing for Installation.
      .timerPrepWait2 -m 1 1000 CInstall.DrawText Preparing for Installation..
      .timerPrepWait3 -m 1 1500 CInstall.DrawText Preparing for Installation...
      .timerInstallWait 1 2 InstallIt 
    }
  }
}

alias -l CInstall.CountUp {
  var %CInstall.FirstNum $int($calc($1 / 100))
  var %CInstall.SecondNum $int($calc($1 / 10))
  var %CInstall.ThirdNum $right($calc($1 / 1),1)
  if (%CInstall.secondNum == 10) { var %CInstall.SecondNum 0 }
  drawpic -n @Install 132 24 $calc(%CInstall.FirstNum * 9) 0 8 13 $scriptdirnumbers.bmp
  drawpic -n @Install 142 24 $calc(%CInstall.SecondNum * 9) 0 8 13 $scriptdirnumbers.bmp
  drawpic -n @Install 152 24 $calc(%CInstall.ThirdNum * 9) 0 8 13 $scriptdirnumbers.bmp
  drawrect -nfr @Install $rgb(0,255,0) 1 31 61 $calc(($1 / 100) * 230) 19
  drawdot @Install
}

alias -l CInstall.DrawText {
  drawrect -nfr @Install $rgb(0,0,0) 1 0 90 300 50 
  var %CInstall.length $len($1-)
  var %CInstall.textToDraw $lower($1-)
  var %CInstall.counter 1
  var %CInstall.xposition 10
  while (%CInstall.counter <= %CInstall.length) {
    if ($mid(%CInstall.textToDraw, [ %CInstall.counter ] , 1) == .) { drawpic -n @Install %CInstall.xposition 95 260 0 8 12 $scriptdirletters2.bmp }
    elseif ($mid(%CInstall.textToDraw, [ %CInstall.counter ] , 1) == !) { drawpic -n @Install %CInstall.xposition 95 270 0 8 12 $scriptdirletters2.bmp }
    elseif ($mid(%CInstall.textToDraw, [ %CInstall.counter ] , 1) == $chr(32)) { }
    else { drawpic -n @Install %CInstall.xposition 95 $calc(($asc($mid(%CInstall.textToDraw, [ %CInstall.counter ] , 1)) - 97) * 10) 0 8 12 $scriptdirletters2.bmp }
    inc %CInstall.xposition 9
    inc %CInstall.counter
  }
  drawdot @Install    
}

; --------------
;   Mouse Menu
; --------------
menu @Install {
  sclick: {
    if (%CInstall.stepNum == 1) {
      if ($inrect($mouse.x,$mouse.y,152,82,85,30) == $true) {
        DrawButtonDown @Install 152 82 85 30 Cancel
        set %CInstall.clicked Cancel
      }
      elseif ($inrect($mouse.x,$mouse.y,57,82,85,30) == $true) {
        DrawButtonDown @Install 57 82 85 30 Next >>
        set %CInstall.clicked Install
      }
      elseif ($inrect($mouse.x,$mouse.y,25,47,10,10) == $true) {
        DrawRadioClicking @Install 25 47 10 10
        set %CInstall.clicked BG1
      }
      elseif ($inrect($mouse.x,$mouse.y,115,47,10,10) == $true) {
        DrawRadioClicking @Install 115 47 10 10
        set %CInstall.clicked BG2
      }
      elseif ($inrect($mouse.x,$mouse.y,205,47,10,10) == $true) {
        DrawRadioClicking @Install 205 47 10 10
        set %CInstall.clicked BG3
      }
      else { }
    }
    elseif (%CInstall.stepNum == 2) {
      if ($inrect($mouse.x,$mouse.y,152,82,85,30) == $true) {
        DrawButtonDown @Install 152 82 85 30 Cancel
        set %CInstall.clicked Cancel
      }
      elseif ($inrect($mouse.x,$mouse.y,57,82,85,30) == $true) {
        DrawButtonDown @Install 57 82 85 30 Install
        set %CInstall.clicked Install
      }
      elseif ($inrect($mouse.x,$mouse.y,215,43,65,20) == $true) {
        DrawButtonDown @Install 215 43 65 20 Change
        set %CInstall.clicked ChangeDir
      }
      else { }
    }
  }
  uclick: {
    if (%CInstall.stepNum == 1) {
      if (($inrect($mouse.x,$mouse.y,152,82,85,30) == $true) && (%CInstall.clicked == Cancel)) {
        DrawButton @Install 152 82 85 30 Cancel
        unset %CInstall.* %Calendar.*
        .timerUnload 1 1 .unload -rs install.mrc
        window -c @Install
      }
      elseif (($inrect($mouse.x,$mouse.y,57,82,85,30) == $true) && (%CInstall.clicked == Install)) {
        if ((%Calendar.background != $null) && (%CInstall.doinstall == yes)) { InstallGui2 }
        else { DrawButton @Install 57 82 85 30 Next >> }
      }
      elseif (($inrect($mouse.x,$mouse.y,410,95,150,20) == $true) && (%CInstall.clicked == ChangeDir)) {
        DrawButton @Install 410 95 150 20 Change Directory
        ChangeInstallDir
      }
      elseif (($inrect($mouse.x,$mouse.y,25,47,10,10) == $true) && (%CInstall.clicked == BG1)) {
        DrawRadioClicked @Install 25 47 10 10
        set %Calendar.background 1
        set %Calendar.bgpicture bg1.bmp
        DrawRadio @Install 115 47 10 10
        DrawRadio @Install 205 47 10 10
      }
      elseif (($inrect($mouse.x,$mouse.y,115,47,10,10) == $true) && (%CInstall.clicked == BG2)) {
        DrawRadioClicked @Install 115 47 10 10
        set %Calendar.background 2
        DrawRadio @Install 25 47 10 10
        DrawRadio @Install 205 47 10 10
      }
      elseif (($inrect($mouse.x,$mouse.y,205,47,10,10) == $true) && (%CInstall.clicked == BG3)) {
        DrawRadioClicked @Install 205 47 10 10
        set %Calendar.background 3
        DrawRadio @Install 25 47 10 10
        DrawRadio @Install 115 47 10 10
      }
      else {
        DrawButton @Install 152 82 85 30 Cancel    
        DrawButton @Install 57 82 85 30 Next >>
      }
    }
    elseif (%CInstall.stepNum == 2) {
      if (($inrect($mouse.x,$mouse.y,152,82,85,30) == $true) && (%CInstall.clicked == Cancel)) {
        DrawButton @Install 152 82 85 30 Cancel
        unset %CInstall.* %Calendar.*
        .timerUnload 1 1 .unload -rs install.mrc
        window -c @Install
      }
      elseif (($inrect($mouse.x,$mouse.y,57,82,85,30) == $true) && (%CInstall.clicked == Install)) {
        if ((%Calendar.background != $null) && (%CInstall.doinstall == yes)) { 
          clear @Install
          InstallGUI3
        }
        else { DrawButton @Install 57 82 85 30 Install }
      }
      elseif (($inrect($mouse.x,$mouse.y,215,43,65,20) == $true) && (%CInstall.clicked == ChangeDir)) {
        DrawButton @Install 215 43 65 20 Change
        ChangeInstallDir
      }
      else {
        DrawButton @Install 152 82 85 30 Cancel    
        DrawButton @Install 57 82 85 30 Install
        DrawButton @Install 215 43 65 20 Change
      }
    }
  }
}